//************************************************************************
// Example12SortComp.java
//
// We demonstrate the usage of the Comparable interface for sorting arrays
// of any type of comparable elements.
//************************************************************************

public class Example12SortComp
{
   public static void main (String[] args)
   {
      String[] myStrings = {"ba0x", "ZZZ", "abc", "abd", "3f6"};
      Arrays myArray = new Arrays (myStrings);
      System.out.println (myArray);
      myArray.selectionSort();
      System.out.println (myArray);

      Integer[] myIntegers = {new Integer (30), new Integer (20),
                              new Integer (-2), new Integer (17)};
      myArray = new Arrays (myIntegers);
      System.out.println (myArray);
      myArray.selectionSort();
      System.out.println (myArray);

      double[] myCoords1 = {3.1, 4, 6.3}, myCoords2 = {3, 4, 6.6},
               myCoords3 = {1, 1, 1}, myCoords4 = {3.1, 4, 6}; 
      Point[] myPoints = {new Point (myCoords1), new Point (myCoords2),
                          new Point (myCoords3), new Point (myCoords4)};
      myArray = new Arrays (myPoints);
      System.out.println (myArray);
      myArray.selectionSort();
      System.out.println (myArray);
   }
}


class Arrays
{
   Comparable[] array;

   Arrays (Comparable[] array)
   {this.array = array;}

   Arrays (Arrays A)
   {this(A.array);}

   void selectionSort()
   {
      for (int i = 0; i < array.length - 1; i++)
         for (int j = i + 1; j < array.length; j++)
            if (array[i].compareTo (array[j]) > 0)
               swap(i,j);
   }// method selectionSort

   void swap (int i, int j)
   {
      Comparable temp = array[i];
      array[i] = array[j];
      array[j] = temp;
   }// method swap
   
   public String toString()
   {
      String result = "";
      for (int i = 0; i < array.length; i++)
         result += array[i] + " ";
      return result;
   }// method toString
}// class IntArray


class Point implements Comparable
{
   private double[] coordinates;

   Point (double[] coordinates)
   {
      this.coordinates = new double[coordinates.length];
      for (int j=0; j < coordinates.length; j++)
         this.coordinates[j] = coordinates[j];
   }// method Point

   Point (Point P)
   {this (P.coordinates);}

   double[] getCoordinates()
   {return coordinates;} 

   int getDimension()
   {return coordinates.length;} 

   public int compareTo (Object Q)
   {
      double sumOfDiffs = 0;
      int result = 0;
      if (Q instanceof Point)
      {
         for (int i=0; i < getDimension(); i++)
            sumOfDiffs += getCoordinates()[i] - ((Point) Q).getCoordinates()[i];
         if (sumOfDiffs != 0)
            result = (int) (sumOfDiffs / Math.abs(sumOfDiffs));
      }
      return result;
   }

   public String toString()
   {
      String result = "(";
      for (int j=0; j < coordinates.length - 1; j++)
         result += coordinates[j] + ", ";
      return result + coordinates[coordinates.length - 1] + ")";
   }// method toString
}// class Point
